<template>
  <div class="container-fluid">
    <div class="row">
      <div class="col-sm-12">
        <div class="card rounded shadow web-only">
          <div class="col-sm-4 mt-3">
            <div class="form-search d-flex align-items-center">
              <i class="fa fa-search" @click="init(0, true)"></i>
              <input
                class="form-control pr-4"
                @keyup.enter="init(0, true)"
                type="search"
                placeholder="Rechercher (Nom)"
                v-model="searchtext"
              />
            </div>
          </div>
          <div class="p-5" v-if="isLoading">
            <fulfilling-bouncing-circle-spinner
              class="mx-auto"
              :animation-duration="2000"
              :size="60"
              :color="'#6D071A'"
            />
          </div>
          <div v-else>
            <div class="card-body">
              <div class="table-responsive">
                <table class="table rounded">
                  <thead>
                    <th>Nom</th>
                    <th>Téléphone</th>
                    <th>Adresse</th>
                    <th>Gérant</th>
                    <th>Statut</th>
                    <th></th>
                  </thead>
                  <tbody>
                    <tr v-for="(admin, i) in admins" :key="i">
                      <td  @click="showAdmin(admin._id)" > {{ admin.name }} </td>
                      <td> {{ admin.phone }} </td>
                      <td> {{ admin.addressAgence }} </td>
                      <td> {{ admin.gerantFullname }} | {{admin.gerantPhone}} </td>
                      <!--  <td> {{ admin.active ? 'activé' : 'désactivé' }} </td>  -->
                      <td v-if=" admin.active">
                        <button type="button" class="btn btn-success btn-sm"
                          @click="changeStatut(admin._id,admin.active)">
                          <i class="las la-sync"></i>
                        </button>
                      </td>
                      <td v-else>
                        <button type="button" class="btn btn-danger btn-sm"
                          @click="changeStatut(admin._id,admin.active)">
                          <!-- <i class="fa fa-redo"></i> -->
                          <i class="las la-sync"></i>
                        </button>
                      </td>
                    </tr>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
const roles = {
  coordonator: "Cordonateur",
  manager: "Manageur",
  rse: "RSE",
  "rlm-antenne": "RLM Antenne",
  rlm: "RLM",
  admin: "Administrateur",
};
export default {
  name: "home",
  data() {
    return {
      admins: [],
      errorMessage: "",

      packs: [],
      newAdmin: {
      },
      creating: false,
      confpassword: "",

      searchtext: "",
      searchtype: "name",
      isLoading: false,
      curPage: 1,
      total: 0,
      perPage: 100,
      sort: {},
    };
  },
  mounted() {
    this.init();
  },
  methods: {
    init(page, resetParams) {
      if (resetParams) {
        this.curPage = 1;
      }

      let query = {
        options: {
          role: "agence",
        },
        filter: {
          text: this.searchtext,
          type: this.searchtype.split("+"),
        },
        sort: this.sort,
        page: this.curPage - 1,
        perPage: this.perPage,
      };

      this.isLoading = true;

      this.$service.listAdmins(query, (err, data) => {
        if (err) {
          console.log(err);
          return;
        }
        
        this.isLoading = false;
        this.total = data.total;
        this.admins = data.admins;
      });
    },
    changeStatut(id,statut){
      let newStatut = !statut;
      console.log(id,newStatut)
      this.$service.updateUser(id,{ active: newStatut},(err, data) => {
          if (err) {
            this.errorMessage = err.data && err.data.message;
            console.log("Error", err.data);
            return;
          }
          
          let datas = {
            admin : localStorage.getItem("adminId"),

            message: 'change status agence: ' + id,
            date: new Date(),
            position : this.center,
          }
          this.$service.create("historiques", datas, (err, data) => {
            if (err) {
              this.errorMessage = err.data && err.data.message;
              return;
            }
            this.$swal.fire("Statut changé !!!", "", "success").then(() => {
              this.init();
            }); 
          });
          
        }
      );
    },
  },
};
</script>